/*
 * Phi Applet Demo
 * phi.java -- main (and hopefully only) class
 * Copyright (C) 1998 Filip Pizlo
 */

import java.awt.*;
import java.applet.*;

public class phi extends Applet implements Runnable {
 public imgcanv canv;
 Button toggle,black,white;
 CheckboxGroup gr;
 public Checkbox two,three;
 Scrollbar speed,layout;
 Image i1,i2;
 Graphics g1,g2;
 Thread th;
 boolean ot=false;
 public Color bg,fg;
 ctscroll diam;
 public void init() {
  i1=createImage(size().width,size().height);
  i2=createImage(size().width,size().height);
  g1=i1.getGraphics();
  g2=i2.getGraphics();
  canv=new imgcanv();
  canv.setimage(i1);
  setLayout(new BorderLayout());
  Panel p1=new Panel();
  toggle=new Button("Start");
  gr=new CheckboxGroup();
  diam=new ctscroll(this,26,1,2,45);
  two=new Checkbox("Two",gr,true);
  three=new Checkbox("Three",gr,false);
  speed=new Scrollbar(Scrollbar.HORIZONTAL,11,1,1,20);
  layout=new ctscroll(this,4,1,1,40);
  black=new Button("Black on White");
  white=new Button("White on Black");
  Panel p2=new Panel();
  p2.setLayout(new GridLayout(2,1));
  p2.add("North",new Label("# of dots:"));
  Panel p3=new Panel();
  p3.setLayout(new GridLayout(1,2));
  p3.add(two);
  p3.add(three);
  p2.add("Center",p3);
  Panel p4=new Panel();
  p4.setLayout(new GridLayout(2,1));
  p4.add(new Label("Speed:     "));
  p4.add(speed);
  Panel p6=new Panel();
  p6.setLayout(new BorderLayout());
  p6.add("West",new Label("Colors:"));
  Panel p10=new Panel();
  p10.setLayout(new GridLayout(2,1));
  p10.add(new Label("Diameter:  "));
  p10.add(diam);
  Panel p7=new Panel();
  p7.setLayout(new GridLayout(1,3));
  p7.add(black);
  p7.add(white);
  p6.add("Center",p7);
  Panel p5=new Panel();
  p5.setLayout(new GridLayout(2,1));
  p5.add(new Label("Distance:    "));
  p5.add(layout);
  p1.add(toggle);
  p1.add(new Panel());
  p1.add(p2);
  p1.add(new Panel());
  p1.add(p4);
  p1.add(new Panel());
  p1.add(p5);
  p1.add(new Panel());
  p1.add(p10);
  Panel p8=new Panel();
  p8.add(p6);
  Panel p9=new Panel();
  p9.setLayout(new BorderLayout());
  p9.add("North",p1);
  p9.add("Center",p8);
  add("North",p9);
  add("Center",canv);
  bg=Color.black;
  fg=Color.white;
  buildtwo();
 }
 public void buildtwo() {
  int dst=layout.getValue();
  int rd=dst*size().width/81;
  int ah=size().height-70;
  g1.setColor(bg);
  g2.setColor(bg);
  g1.fillRect(0,0,size().width,size().height);
  g2.fillRect(0,0,size().width,size().height);
  g1.setColor(fg);
  g2.setColor(fg);
  g1.fillOval(size().width/2-rd-10,ah/2-10,diam.getValue(),diam.getValue());
  g2.fillOval(size().width/2+rd-10,ah/2-10,diam.getValue(),diam.getValue());
  canv.repaint();
 }
 public void buildthree() {
  int dst=layout.getValue();
  int rd=dst*size().width/40;
  int ah=size().height-70;
  g1.setColor(bg);
  g2.setColor(bg);
  g1.fillRect(0,0,size().width,size().height);
  g2.fillRect(0,0,size().width,size().height);
  g1.setColor(fg);
  g2.setColor(fg);
  g1.fillOval(size().width/2-rd-10,ah/2-10,diam.getValue(),diam.getValue());
  g1.fillOval(size().width/2+rd-10,ah/2-10,diam.getValue(),diam.getValue());
  g2.fillOval(size().width/2-10,ah/2-10,diam.getValue(),diam.getValue());
  canv.repaint();
 }
 public void build() {
  if (two.getState()) buildtwo();
  else buildthree();
 }
 public boolean action(Event evt,Object arg) {
  if (evt.target==toggle) {
   if (toggle.getLabel().equals("Start")) {
    go();
   } else {
    ungo();
   }
   return true;
  }
  if (evt.target==two) {
   buildtwo();
   return true;
  }
  if (evt.target==three) {
   buildthree();
   return true;
  }
  if (evt.target==black) {
   bg=Color.white;
   fg=Color.black;
   build();
   return true;
  }
  if (evt.target==white) {
   fg=Color.white;
   bg=Color.black;
   build();
   return true;
  }
  return false;
 }
 public void run() {
  try {
   while (true) {
    Thread.sleep(1000/speed.getValue());
    canv.setimage(i2);
    ot=true;
    Thread.sleep(1000/speed.getValue());
    canv.setimage(i1);
    ot=false;
   }
  } catch (Throwable e) {
   System.err.println("Error in thread: "+e);
  }
 }
 public void go() {
  toggle.setLabel("Stop");
  th=new Thread(this);
  th.start();
 }
 public void ungo() {
  toggle.setLabel("Start");
  try {
   th.stop();
   th=null;
  } catch (Throwable e) {}
 }
 public void stop() {
  ungo();
 }
}

